// Dice.cpp

#include "dice.h"

using namespace std;

Dice::Dice(int count) {
    this->diceValues = new int[count];
    this->count = count;
    for (int i = 0; i < count; i++) {
        diceValues[i] = 6;
    }
}

Dice::~Dice() {
    delete[] diceValues;
}

int Dice::getCount() const {
    return count;
}

int Dice::getValue(int index) const {
    return diceValues[index];
}

void Dice::roll(int index) {
    if (index < 0 || index >= count) {
        throw index;
    }
    diceValues[index] = randomInteger(1, 6);
}

void Dice::setValue(int index, int value) {
    if (index < 0 || index >= count) {
        throw index;
    }
    diceValues[index] = value;
}

int Dice::total() const {
    int tot = 0;
    for (int i = 0; i < count; i++) {
        tot += diceValues[i];
    }
    return tot;
}

string Dice::toString() const {
    ostringstream out;
    out << "{";
    if (count > 0) {
        out << diceValues[0];
        for (int i = 1; i < count; i++) {
            out << ", " << diceValues[i];
        }
    }
    out << "}";
    return out.str();
}

ostream& operator <<(ostream& out, const Dice &dice) {
    out << dice.toString();
    return out;
}
