// Dice.h

#include <string>
#include <iostream>
#include <sstream>
#include "random.h"

#pragma once

class Dice {
public:
    Dice(int count);
    ~Dice();
    virtual int getCount() const;
    virtual int getValue(int index) const;
    virtual void roll(int index);
    virtual int total() const;
    virtual std::string toString() const;
    friend std::ostream& operator <<(std::ostream& out, const Dice& dice);

    
private:
    int* diceValues;
    int count;

    void setValue(int index, int value);   // not to be called by students
};
